'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Fetch = function (_Component) {
  _inherits(Fetch, _Component);

  function Fetch() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Fetch);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Fetch.__proto__ || Object.getPrototypeOf(Fetch)).call.apply(_ref, [this].concat(args))), _this), _this.state = { fetching: false, response: null, data: null, error: null }, _this.fetch = function () {
      var body = arguments.length <= 0 || arguments[0] === undefined ? _this.props.body : arguments[0];

      return new Promise(function (resolve, reject) {
        _this.setState({ fetching: true }, function () {
          (0, _axios2.default)({
            method: _this.props.method,
            url: _this.props.url,
            params: _this.props.params,
            headers: _this.props.headers,
            data: body
          }).then(function (response) {
            if (_this.willUnmount) {
              return;
            }
            _this.setState({ fetching: false, response: response, data: response.data }, function () {
              if (_this.props.onResponse) {
                _this.props.onResponse(response);
              }
              if (_this.props.onData) {
                _this.props.onData(_this.state.data);
              }
              resolve(_this.state.data);
            });
          }).catch(function (error) {
            if (_this.willUnmount) {
              return;
            }
            if (!error.response) {
              throw new Error(error.message + ' on ' + _this.props.method.toUpperCase() + ' ' + _this.props.url);
            }
            _this.setState({
              fetching: false,
              response: error.response,
              error: error.response.data
            }, function () {
              if (_this.props.onResponse) {
                _this.props.onResponse(error.response);
              }
              if (_this.props.onError) {
                _this.props.onError(_this.state.error);
              }
              reject(_this.state.error);
            });
          });
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Fetch, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.props.lazy) {
        this.fetch();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!this.props.lazy && !(0, _isEqual2.default)(this.props, nextProps)) {
        this.fetch();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.willUnmount = true;
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(_extends({}, this.state, { fetch: this.fetch }));
    }
  }]);

  return Fetch;
}(_react.Component);

Fetch.propTypes = {
  method: _react.PropTypes.oneOf(['get', 'post', 'put', 'delete']),
  url: _react.PropTypes.string.isRequired,
  params: _react.PropTypes.object,
  headers: _react.PropTypes.object,
  body: _react.PropTypes.object,
  lazy: _react.PropTypes.bool,
  onResponse: _react.PropTypes.func,
  onData: _react.PropTypes.func,
  onError: _react.PropTypes.func,
  children: _react.PropTypes.func.isRequired
};
Fetch.defaultProps = { method: 'get' };
exports.default = Fetch;