'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Paginator = function (_Component) {
  _inherits(Paginator, _Component);

  function Paginator() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Paginator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Paginator.__proto__ || Object.getPrototypeOf(Paginator)).call.apply(_ref, [this].concat(args))), _this), _this.state = { currentPage: _this.props.initialPage }, _this.setPage = function (page) {
      if (typeof page !== 'number') {
        throw new Error('page should be a number');
      }
      if (page < 1) {
        throw new Error('page should be greater than or equal to 1');
      }
      if (page > _this.props.numberOfPages) {
        throw new Error('page should be less than or equal to ' + _this.props.numberOfPages);
      }
      _this.setState({ currentPage: page }, function () {
        if (_this.props.onPageChange) {
          _this.props.onPageChange(page);
        }
      });
    }, _this.incrementPage = function () {
      if (_this.state.currentPage === _this.props.numberOfPages) {
        return;
      }
      _this.setPage(_this.state.currentPage + 1);
    }, _this.decrementPage = function () {
      if (_this.state.currentPage === 1) {
        return;
      }
      _this.setPage(_this.state.currentPage - 1);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Paginator, [{
    key: 'render',
    value: function render() {
      return this.props.children(_extends({}, this.state, {
        numberOfPages: this.props.numberOfPages,
        setPage: this.setPage,
        incrementPage: this.incrementPage,
        decrementPage: this.decrementPage
      }));
    }
  }]);

  return Paginator;
}(_react.Component);

Paginator.propTypes = {
  initialPage: function initialPage(props) {
    if (typeof props.initialPage !== 'number') {
      return new Error('initialPage should be a number');
    }
    if (props.initialPage < 1) {
      return new Error('initialPage should be greater than or equal to 1');
    }
    if (props.initialPage > props.numberOfPages) {
      return new Error('initialPage should be less than or equal to ' + props.numberOfPages);
    }
  },
  numberOfPages: _react.PropTypes.number.isRequired,
  onPageChange: _react.PropTypes.func,
  children: _react.PropTypes.func.isRequired
};
Paginator.defaultProps = { initialPage: 1 };
exports.default = Paginator;