'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _evee = require('evee');

var _evee2 = _interopRequireDefault(_evee);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var evee = new _evee2.default();

var Storage = function (_Component) {
  _inherits(Storage, _Component);

  function Storage() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Storage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Storage.__proto__ || Object.getPrototypeOf(Storage)).call.apply(_ref, [this].concat(args))), _this), _this.state = _this.getSubscribedKeys().reduce(function (result, key) {
      return _extends({}, result, _defineProperty({}, key, _this.props.driver.getItem(key) || _this.props.initialValues[key] || null));
    }, {}), _this.setItem = function (key, value) {
      _this.props.driver.setItem(key, value);
      evee.emit(key, value);
      return value;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Storage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.subscriptions = this.getSubscribedKeys().map(function (key) {
        return evee.on(key, function (event) {
          return !_this2.willUnmount && _this2.setState(_defineProperty({}, key, event.data));
        });
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.willUnmount = true;
      this.subscriptions.forEach(function (subscription) {
        return evee.drop(subscription);
      });
    }
  }, {
    key: 'getSubscribedKeys',
    value: function getSubscribedKeys() {
      if (!this.props.subscribe) {
        return [];
      }
      if (typeof this.props.subscribe === 'string') {
        return [this.props.subscribe];
      }
      return this.props.subscribe;
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(_extends({}, this.state, { setItem: this.setItem }));
    }
  }]);

  return Storage;
}(_react.Component);

Storage.propTypes = {
  initialValues: _react.PropTypes.object,
  subscribe: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.arrayOf(_react.PropTypes.string)]),
  driver: _react.PropTypes.shape({
    getItem: _react.PropTypes.func.isRequired,
    setItem: _react.PropTypes.func.isRequired
  }).isRequired
};
Storage.defaultProps = { initialValues: {} };
exports.default = Storage;