'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Validator = function (_Component) {
  _inherits(Validator, _Component);

  function Validator() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Validator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Validator.__proto__ || Object.getPrototypeOf(Validator)).call.apply(_ref, [this].concat(args))), _this), _this.getErrors = function () {
      var errors = Object.keys(_this.props.validations).reduce(function (result, path) {
        var validations = _this.props.validations[path];
        if (!(0, _isArray2.default)(validations)) {
          throw new Error('validations[' + path + '] should be an array');
        }
        return _extends({}, result, _defineProperty({}, path, validations.map(function (validation, index) {
          if (typeof validation !== 'function') {
            throw new Error('validations[' + path + '][' + index + '] should be a function');
          }
          var error = validation((0, _get2.default)(_this.props.values, path, ''), _this.props.values);
          if (error && typeof error !== 'string') {
            throw new Error('validations[' + path + '][' + index + '] should return a string');
          }
          return error;
        }).find(function (error) {
          return error;
        })));
      }, {});
      return Object.keys(errors).find(function (path) {
        return errors[path];
      }) ? errors : null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Validator, [{
    key: 'render',
    value: function render() {
      return this.props.children({ errors: this.getErrors() });
    }
  }]);

  return Validator;
}(_react.Component);

Validator.propTypes = {
  validations: _react.PropTypes.object.isRequired,
  values: _react.PropTypes.object,
  children: _react.PropTypes.func.isRequired
};
exports.default = Validator;